// The round function is from MDN somewhere, perhaps the Math.round page.
// See round10.js for the original version.

/**
 *
 * Decimal adjustment of a number.
 *
 * @param   {String}    type    The type of adjustment.
 * @param   {Number}    value   The number.
 * @param   {Integer}   exp     The exponent (the 10 logarithm of the adjustment base).
 * @returns {Number}            The adjusted value.
 */
function round(value, exp) {
    // If the exp is undefined or zero...
    if (typeof exp === 'undefined' || +exp === 0) {
        return Math.round(value);
    }
    value = +value;
    exp = +exp;

    // If the value is not a number or the exp is not an integer...
    if (isNaN(value) || !(typeof exp === 'number' && exp % 1 === 0)) {
        return NaN;
    }
    // Shift
    value = value.toString().split('e');
    value = Math.round(+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp)));

    //console.log(value);
    // Shift back
    value = value.toString().split('e');

    return +(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp));
}




for ( var i = 0; i < 100; i++ ) {

    var n = (Math.random() + '').slice( -( Math.random() * 10 | 0 ) ) + 'e' + ( Math.random() * 5 | 0 );
    n = (+n + '').slice(0, 16);
    var e = Math.random() * 20 | 0;
    e *= -1;

    var x = round(n, e) + '';
    var y = new BigNumber(n + '').toMagnitude(e) + '';

    console.log(x);
    console.log(y);

    if ( x !== y ) {
        console.log( 'n: ' + n );
        console.log( 'e: ' + e );
        throw 'Mismatch!';
    }
    console.log();
}

